; #########################################################################
	.586
	.model flat, stdcall
	option casemap :none   ; case sensitive

; #########################################################################

	include \masm32\include\windows.inc
	include \masm32\include\user32.inc
	include \masm32\include\kernel32.inc
	include  \MASM32\include\masm32.inc
	
	includelib \masm32\lib\user32.lib
	includelib \masm32\lib\kernel32.lib
	includelib \masm32\lib\masm32.lib
	
	ThreadMoreRandom PROTO :DWORD
	ThreadLessRandom PROTO :DWORD
	WndRandom PROTO  :DWORD,  :DWORD,  :DWORD,  :DWORD 
	MainRandom PROTO 
	EcrireFichier PROTO  :DWORD 

	
	 MEMHEAP STRUCT
                Hheap dd ?      ;Handle heap,GetProcessHeap
                Pheap dd ?      ;Pointeur heap,HeapAlloc
                Theap dd ?      ;taille du bloc Heap  buffer.Theap
		  Pdata dd ?
        MEMHEAP ENDS

	STHREAD STRUCT
		Htread dd ?
		threadid dd ?
	STHREAD ENDS
	;-------------------------------------- macros ------------------------------------------------
		ZEROLOCALES MACRO dernierelocale:REQ
			mov ecx,ebp
			lea edx,dernierelocale
			sub ecx,edx
			.if ecx != 0
				push edi
				mov edi,edx
				mov al,0
				cld
				rep stosb
				pop edi			
			.endif
		ENDM
		PuPo MACRO M1, M2
			push M2
			pop  M1
		ENDM		
			
	;---------------------------------------------------------------------------------------------			

.data
	Hinstance dd 0
	Tcompile STHREAD <>
	szClassName db "invisible",0
	ThreadTerminate dd 0
	MiniMum dd 0
	Maximum dd 0
	hWnd dd 0	
	random dd 0
	byterandom db 0,0
	asciirandom db 20 dup (0)
	espace db " ",0
	CPT dd 0
	szrandom db "random",0
	szFin db "Fini",0
	buffer MEMHEAP <>
	fsortie db "random.txt",0
	hsortie dd 0
	Nbmessages dd 0
	
.code
start:
	invoke GetModuleHandle,NULL
	mov Hinstance,eax
	;--------- define the limits ------------------------
	mov MiniMum,0
	mov Maximum,100
	mov CPT,1000			;numbers of random to generate
	
	;--------------------------------------------------------
	invoke MainRandom
	invoke ExitProcess,0
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
MainRandom PROC 
	LOCAL msg  :MSG
	LOCAL wc   :WNDCLASSEX
	Local  retour:DWORD
	ZEROLOCALES retour
	;-------- create the buffer
	mov eax,CPT
	xor edx,edx
	mov ecx,11			;10 caracteres + zero
	mul ecx
	mov buffer.Theap,eax
	
	invoke GlobalAlloc,GMEM_ZEROINIT,buffer.Theap
	.if eax == 0
		mov retour,0
		jmp FindeMainRandom 
	.else
		mov buffer.Hheap,eax
		invoke GlobalLock,buffer.Hheap
		.if eax == 0
			invoke GlobalFree,buffer.Hheap
			mov retour,0
			jmp FindeMainRandom
		.else
			mov buffer.Pheap,eax
			mov buffer.Pdata,eax
		.endif
	.endif

	;==================================================
	; create a not visible window
	;==================================================

	mov wc.cbSize,         sizeof WNDCLASSEX
	mov wc.style,          CS_HREDRAW or CS_VREDRAW 
	mov wc.lpfnWndProc,    offset WndRandom        
	PuPo wc.hInstance,      Hinstance   
	mov wc.hbrBackground,  COLOR_BTNFACE+1
	mov wc.lpszClassName,  offset szClassName

	invoke RegisterClassEx, ADDR wc

	invoke CreateWindowEx,0,ADDR szClassName,0,0,0,0,0,0,0,0,Hinstance,0
	.if eax == 0
			invoke GlobalUnlock,buffer.Hheap
			invoke GlobalFree,buffer.Hheap
			mov retour,0
			jmp FindeMainRandom				
	.endif
	invoke PostMessage,hWnd,WM_COMMAND,1000,0
	
	StartLoop:
	invoke GetMessage,ADDR msg,NULL,0,0		;wait for all randoms create
	.if eax != 0
		.if eax != -1 ;invalid handle
			invoke TranslateMessage, ADDR msg
			invoke DispatchMessage,  ADDR msg
		.endif
		jmp StartLoop
	.endif	
	;--------------- view the result -------------------------------
	mov edx,buffer.Pheap
	invoke EcrireFichier,addr fsortie
	invoke GlobalUnlock,buffer.Hheap
	invoke GlobalFree,buffer.Hheap	
	invoke MessageBox,NULL,addr szFin,addr szrandom,MB_OK	
FindeMainRandom:
	mov eax,retour
	ret
MainRandom endp
;#########################################################################################################

ThreadLessRandom PROC Nothing:DWORD 
	mov eax,Maximum
	@@:
	.if ThreadTerminate != 1			;is time paste ? ,NOT
		.if eax != MiniMum  			;loop inside all possibles values of eax
		dec eax				; 
			jmp @B
		.else 
			mov eax,Maximum
			jmp @B
		.endif
	.endif
	mov random,eax
	mov ThreadTerminate,0			; for the next number
	invoke dwtoa,random,addr asciirandom
	invoke szCatStr,addr asciirandom,addr espace
	push esi
	push edi
	lea esi,asciirandom
	mov edi,buffer.Pdata
	@@:
	mov al,[esi]
	.if al != 0
		stosb
		inc esi
		jmp @B
	.endif
	mov [edi],al
	mov buffer.Pdata,edi
	pop edi
	pop esi
	
	dec CPT
	.if CPT != 0
		invoke PostMessage,hWnd,WM_COMMAND,1000,0 ;relancer la roue
	.else
		invoke PostMessage,hWnd,WM_CLOSE,NULL,NULL	; close the window		
	.endif	
	mov Nbmessages,0
	invoke ExitThread,random
	ret
ThreadLessRandom endp
;----------------------------------------------------------------------

ThreadMoreRandom PROC Nothing:DWORD 
	mov eax,MiniMum
	@@:
	.if ThreadTerminate != 1			;is time paste ? ,NOT
		.if eax != Maximum 			;loop inside all possibles values of eax
		inc eax				; 
			jmp @B
		.else 
			mov eax,MiniMum
			jmp @B
		.endif
	.endif
	mov random,eax
	mov ThreadTerminate,0			; for the next number
	invoke dwtoa,random,addr asciirandom
	invoke szCatStr,addr asciirandom,addr espace
	push esi
	push edi
	lea esi,asciirandom
	mov edi,buffer.Pdata
	@@:
	mov al,[esi]
	.if al != 0
		stosb
		inc esi
		jmp @B
	.endif
	mov [edi],al
	mov buffer.Pdata,edi
	pop edi
	pop esi
	
	dec CPT
	.if CPT != 0
		invoke PostMessage,hWnd,WM_COMMAND,1000,0 ;relancer la roue
	.else
		invoke PostMessage,hWnd,WM_CLOSE,NULL,NULL	; close the window		
	.endif	
	mov Nbmessages,0
	invoke ExitThread,random
	ret
ThreadMoreRandom endp
;----------------------------------------------------------------------
;################################################################
WndRandom proc  hwnd:DWORD, wMsg, wParam, lParam
	LOCAL retour:DWORD
	mov eax,hwnd
	mov hWnd,eax
	
	.if wMsg == WM_COMMAND
		.if wParam == 1000
			.if Tcompile.Htread != 0
				invoke CloseHandle,Tcompile.Htread		;close the thread	
				mov Tcompile.Htread,0
			.endif
			;----------------------- first choice random ,inc or dec the numbers
			
        		RDTSC                   		; read the the counter of cycles
			and eax,1				; keep only the first bit,that change allways
			.if eax == 1		;inc 			
				;-------------- create a thread that inc the numbers --------------------------
				invoke CreateThread,NULL,NULL,ThreadMoreRandom,NULL,NULL,addr Tcompile.threadid
				mov Tcompile.Htread,eax
			.else
			;-------------- create a thread that dec the numbers --------------------------
				invoke CreateThread,NULL,NULL,ThreadLessRandom,NULL,NULL,addr Tcompile.threadid
				mov Tcompile.Htread,eax			
			.endif
			;pass time
			invoke SetTimer,hWnd,400,1,NULL		;wait one millisecond and put the test to 1							
		.endif
		mov retour,0

	.elseif wMsg == WM_TIMER
		invoke KillTimer,hWnd,400			
		mov ThreadTerminate,1			;stop the thread
		mov retour,0 ; valeur de retour
	.elseif wMsg == WM_CLOSE || wMsg == WM_DESTROY	
		invoke PostQuitMessage,NULL
		mov retour,0			
	.else
		invoke DefWindowProc,hwnd, wMsg, wParam, lParam
		mov retour,eax
	.endif
	mov eax,retour
	ret
WndRandom endp


;################################################################
EcrireFichier PROC  NomFichier:DWORD 
			Local  retour:DWORD
			Local   BytesWritten:DWORD
			;Local    [MAX_PATH +1]:BYTE 
         mov retour,1
       invoke CreateFile,NomFichier,GENERIC_WRITE,0,0,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,0
          .if eax==INVALID_HANDLE_VALUE
			;invoke  MessageBox,NULL,SADR("erreur ouverture fichier "),SADR("OuvrirEcriture"),MB_OK
			mov retour,0
	   .endif
	mov retour,eax
	mov edx,buffer.Pdata
	sub edx,buffer.Pheap
	inc edx		;add zero
	invoke WriteFile,retour,buffer.Pheap,edx,addr BytesWritten,0
	invoke CloseHandle,retour

 FindeEcrireFichier:
         mov eax,retour
         ret
EcrireFichier endp

;################################################################
	
end start